#include "InformationServer.h"
#include <Zeit.h>
#include <iostream>
#include <fstream>
#include <Globals.h>
#include <sys/resource.h>

int main()
{
    struct rlimit core_limits;
    core_limits.rlim_cur = core_limits.rlim_max = RLIM_INFINITY;
    setrlimit( RLIMIT_CORE, &core_limits );
#ifdef DEBUG
    //cd( "/test/information" );
#endif
    Framework::initFramework();
    Zeit *z = getZeit();
    Text *pfad = new Text( "../log/information/" );
    pfad->append( z->getZeit( "y-m-d h-i-s.log" ) );
    z->release();
    DateiPfadErstellen( pfad->getText() );
    std::ofstream file;
    file.open( pfad->getText() );
    std::streambuf *sbuf = std::cout.rdbuf();
    std::cout.rdbuf( file.rdbuf() );
    pfad->release();

    std::cout << "IS: Startet...\n";
    std::cout << "IS: Lese init Datei ../data/isInit.ini ...\n";
    InitDatei *dat = new InitDatei( "../data/isInit.ini" );
    if( !dat->laden() )
    {
        std::cout << "IS: error: Datei konnte nicht gelesen werden. Das Programm wird geschlossen.\n";
        dat->release();
        exit( 1 );
    }
    const char *wichtig[] = { "ServerId", "DBBenutzer", "DBPasswort", "DBName", "DBIP", "DBPort", "Aktiv", "SSLCert", "SSLKey", "SSLPasswort" };
    for( const char *w : wichtig )
    {
        if( !dat->wertExistiert( w ) )
        {
            std::cout << "IS: error: Der Wert '" << w << "' wurde nicht gefunden. Das Programm wird geschlossen.\n";
            dat->release();
            exit( 1 );
        }
    }

    InformationServer *iServer = new InformationServer( dat );

    std::cout << "IS: Der Admin Server läuft. Startforgang beendet.\n";
    iServer->runn();

    iServer->ende();
    iServer->release();
    dat->release();
    std::cout << "IS: Der Server ist heruntergefahren.\n";
    file.close();
    std::cout.rdbuf( sbuf );
    Framework::releaseFramework();
    return 0;
}